<?php
// cms/api/transactions/delete

    header("Content-Type:application/json");
    include("../../../settings/dbconn.php");
    include("../../../settings/utils.php");
    
    // parametros obligatorios
    $parmsob = array("sessionid",'id');
    if (!parametrosValidos($_GET, $parmsob))
        badEnd("400", array("msg"=>"Parametros obligatorios " . implode(", ", $parmsob)));
    
    //Declaramos e inicializamos nuestras variables
    $out = new stdClass();
    $sessionid = mysqli_real_escape_string($db, $_GET["sessionid"]);
    $id = mysqli_real_escape_string($db, $_GET['id']);
    
    //Validamos que la session del usuario sea valida para continuar
    isSessionValidCMS($db, $sessionid);
    
    //Validamos que el usuario tenga privilegios
    if(!tienePrivilegio($db, $sessionid, 39))
        badEnd("403", array("msg"=>"No tiene Privilegios"));
    
    // Validamos que exista el registro
    $sql = "SELECT COUNT(id) AS qty FROM transactions WHERE txid = ".$id;
    if (!$rs=$db->query($sql))
        badEnd("500", array("msg"=>determinateDBError($db)));
            
    $row = $rs->fetch_assoc();
        
    // Retornamos 404 cuando la busqueda no obtiene resutados
    if($row['qty'] == 0){
        badEnd("204", array("msg"=>"No se encuentra el registro"));
    }
    
    // Validamos que exista el registro
    $sql = "SELECT * FROM transactions WHERE txid = ".$id;
    if (!$rs=$db->query($sql))
        badEnd("500", array("msg"=>determinateDBError($db)));
            
    $row = $rs->fetch_assoc();
    
    $sql = "DELETE FROM transactions WHERE txid = ".$id;
    if (!$db->query($sql)){
        if ($db->errno == 1451)
            badEnd("304",array("msg"=>"Existen dependencias que no permiten eliminar esta Cuenta"));
        else
            badEnd("500",array("msg"=>determinateDBError($db)));
    }
        
    //Retornamos 304 si no se actualizo ningun registro
    if ($db->affected_rows == 0)
        badEnd("304", array("msg"=>"No se pudo modificar"));
    
    $out->id = (int)$id;
    
    // Con el id de la cuenta obtenemos el correo del usuario
    $sql = "SELECT users.usr AS usr ".
    "       FROM users, accounts ".
    "       WHERE accounts.id = ".$row['accountid'].
    "       AND accounts.userid = users.id";
    if (!$res=$db->query($sql))
        badEnd("500", array("msg"=>determinateDBError($db)));
            
    $rowUser = $res->fetch_assoc();
    
    // Obtenemos los datos de la moneda
    $sql = "SELECT currencies.decimals AS decimals, ".
    "       currencies.symbol AS symbol ".
    "       FROM currencies, accounts ".
    "       WHERE currencies.id = accounts.currencyid ".
    "       AND accounts.id = ".$row['accountid'];
    if (!$res=$db->query($sql))
        badEnd("500", array("msg"=>determinateDBError($db)));
            
    $currencydata = $res->fetch_assoc();
    
    //auditoria
    setAudit($db, "TRANSACCIONES", $sessionid, "CMS", "Se eliminó un ajuste de ".number_format($row['amount'], $currencydata['decimals'], '.', ',')." ".$currencydata['symbol']." al usuario ".$rowUser['usr']);
    
    header("HTTP/1.1 200");
    echo (json_encode($out));
    die();
?>
